#include <stdlib.h>
#include <stdio.h>



#define IMPERSONATE_REQUESTING_USER 1 // #undef to skip RpcImpersonateClient()
#define PRINT_FULL_AUTHINFO_ON_EVERY_CALL 1 // #undef to make the thing go _waaay_ faster
// Warning: Having XMIT_NOT_ONLY_STRINGS defined will **invalidate** throughput measurements!
// #define XMIT_NOT_ONLY_STRINGS 1 // #undef to return unions with strings only.



#undef XMIT_NOT_ONLY_STRINGS
#undef PRINT_FULL_AUTHINFO_ON_EVERY_CALL


extern "C"
{
	#include "inout.h"    // header file generated by MIDL compiler

	extern int useauthn; // desired authentication level
	extern int use_security_callback; // != 0 if non-auth'ed users are kicked off in inouts.c
}



void ping( handle_t IDL_handle )
{
	(void) IDL_handle;
}



long raiseex( handle_t IDL_handle, error_status_t *e )
{
	(void) IDL_handle;
	(void) e;
	RpcRaiseException( 9999 );
	return 0;
}



void inout4( handle_t IDL_handle, long size, long count, a_t __RPC_FAR * __RPC_FAR *w )
{
	int i, strsize;

	if ( useauthn )
	{
		RPC_STATUS rc;
		unsigned long level, authnsvc, authzsvc;
		unsigned char *princname = NULL;
		// CAUTION -- according to the docs, you can pass NULL instead of &foo to
		// RpcBindingInqAuthClient().  THIS IS NOT CORRECT.  The NT 3.51 and Win95
		// 4.00.950 runtime will hit an access violation if you pass in NULL for
		// the second argument.
		RPC_AUTHZ_HANDLE foo = NULL;

		// if you chose to use the security callback, RBIAC() should always succeed.
		// since unauthenticated users are, in that case, kicked off by the security
		// callback, you can continue with impersonating the client, no more tests
		// necessary.

		if ( ! use_security_callback )
		{
			rc = RpcBindingInqAuthClient( IDL_handle, &foo, &princname, &level, &authnsvc, &authzsvc );
		
			if ( rc )
				printf( "RpcBindingInqAuthClient() returned %d\n", rc );
#ifdef PRINT_FULL_AUTHINFO_ON_EVERY_CALL
			else
			{
				printf( "Authenticated client. We are called {%s}; the protect level is %ld.\n",
				  princname, level );
				printf( "Authentication service %ld, authorization service %ld.\n", authnsvc, authzsvc );
			}
#endif

			//* impersonate client, get name & credentials &c...

			if ( princname != NULL )
				RpcStringFree( &princname );
		}

		// using a security callback? continue reading here!

#ifdef IMPERSONATE_REQUESTING_USER
		i = RpcImpersonateClient( NULL );
		if ( i != 0 )
		{
			printf( "RIC() returned %d\n", i );
		}
		else
		{
			char uname[200];
			DWORD j;
			j = sizeof uname;
			if ( GetUserName( uname, &j ) )
				printf( "user name: %s\n", uname );
			RpcRevertToSelf();
		}
#endif
	}


	if ( *w != NULL )
	{
		for ( i = 0; i < (*w)->len; i ++ )
		{
			if ( (*w)->a[i].t == e_string && (*w)->a[i].vu.u_string != NULL )
				midl_user_free( (*w)->a[i].vu.u_string );
		}
		midl_user_free( *w );
	}
	*w = NULL;

	*w = (a_t *) RpcSsAllocate( sizeof( **w ) + ( count - 1L ) * sizeof( (*w)->a[0] ) );
	(*w)->len = count;
	for ( i = 0; i < count; i ++ )
	{
#ifdef XMIT_NOT_ONLY_STRINGS // enable to make every other union a rights_t instead of a string
		if ( i & 1 )
		{
#endif
			strsize = ( size == 0? i + 1: size );
			(*w)->a[i].t = e_string;
			(*w)->a[i].vu.u_string = (unsigned char *) RpcSsAllocate( strsize );
			if ( strsize > 1 )
				memset( (*w)->a[i].vu.u_string, 'x', strsize - 1L );
			((*w)->a[i].vu.u_string)[strsize - 1L] = '\0';
#ifdef XMIT_NOT_ONLY_STRINGS // enable to make every other union a rights_t instead of a string
		}
		else
		{
			(*w)->a[i].t = e_rights_f;
			(*w)->a[i].vu.u_rights_f.user_group = 0x123456789abcdef0;
			(*w)->a[i].vu.u_rights_f.permission = 0x76543210;
		}
#endif
	}
}

void Shutdown( handle_t IDL_handle )
{
    RPC_STATUS status;

    printf("Calling RpcMgmtStopServerListening\n");
    status = RpcMgmtStopServerListening(NULL);
    printf("RpcMgmtStopServerListening returned: 0x%x\n", status);
    if (status) {
        exit(status);
    }

    printf("Calling RpcServerUnregisterIf\n");
    status = RpcServerUnregisterIf(NULL, NULL, FALSE);
    printf("RpcServerUnregisterIf returned 0x%x\n", status);
    if (status) {
        exit(status);
    }
}

/* end file inoutp.c */
